#--
# Copyright (C) 2007  Sun Microsystems, Inc.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#++

module ActiveResource::AttributeHelper
  module ClassMethods
    def attribute_types
      @attribute_types
    end
    def remote_attr(name, type)
      @attribute_types ||= {}.with_indifferent_access
      column = ActiveRecord::ConnectionAdapters::Column.new(name, nil)
      column.send :instance_variable_set, "@type", type
      @attribute_types[name] = column
      module_eval <<CODE, __FILE__, __LINE__
        def #{name}
          attributes["#{name}"]
        end
        def #{name}=(val)
          attributes["#{name}"] = type_cast("#{name}", val)
        end
CODE
    end
  end
  module InstanceMethods
    def type_cast(field, val)
      self.class.attribute_types[field].type_cast(val)
    end
    def to_param
      self.id.to_s
    end
  end
end

ActiveResource::Base.send(:include, ActiveResource::AttributeHelper::InstanceMethods)
ActiveResource::Base.send(:extend, ActiveResource::AttributeHelper::ClassMethods)
