gem 'atom-tools'
require 'atom/feed'

class Entry < RailsUtils::Model::Tableless
  # Tableless bits

  column :id, :string
  column :uri, :string
  column :title, :string
  column :content, :string
  column :published, :datetime

  class << self
    def list(*args)
      feed = Atom::Feed.new "#{site}/entries", connection
      feed.update!
      feed.map do |entry|
        Entry.new.load_from_atom_entry entry
      end
    end
  end

  def load(*args)
     load_from_atom_entry connection.get_atom_entry("#{site}/entry/#{id}")
  end

  def create
    xml = to_atom_entry.to_xml
    puts xml
    response = connection.post "#{site}/entries", xml
      {"Content-Type" => "application/atom+xml" }
    puts response
    load_from_atom_entry Atom::Entry.parse(response.body)
    self.new_record = false
    true
  end

  def update
  end

  def destroy
  end

  # Atom bits

  cattr_accessor :site, :connection

  self.site = "http://localhost:8080/roller/roller-services/app/nicksden"
  self.connection = returning Atom::HTTP.new do |http|
    http.user = "nick"
    http.pass = "123123"
    http.always_auth = :basic
  end

  def load_from_atom_entry(entry)
    self.attributes = {:title => entry.title, :content => entry.content, :published => entry.published}
    self.id = entry.edit_url =~ %r{/([^/]+)$} && $1
    self.uri = entry.edit_url
    self.new_record = false
    self
  end
  
  def to_atom_entry
    returning Atom::Entry.new do |entry|
      entry.id = self.uri
      entry.title = self.title
      entry.content = Atom::Content.new self.content, "content"
      entry.content["type"] = "html"
    end
  end
end