#--
# Copyright (C) 2007  Sun Microsystems, Inc.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#++

module RailsUtils
  module Controller
    # Usage -- in your controller:
    #     around_filter RailsUtils::Controller::Profiler
    # Then, pass a "_profile=on" parameter in your URL to activate profiling 
    # for that request.
    class Profiler
      def self.before
        @_profile = params[:_profile]
        if @_profile == "on"
          require 'profiler'
          Profiler__::start_profile
        end
      end

      def self.after
        if @_profile == "on"
          Profiler__::stop_profile
          require 'stringio'
          prof = StringIO.new
          Profiler__::print_profile(prof)
          logger.info(prof.string)
        end
        @_profile = nil
      end
    end
  end
end

# this is needed for JRuby currently, it passes nil to #set_trace_func sometimes
class NilClass #:nodoc:
  def id2name
    "<nil>"
  end
end
